/*
 * Boot-related utilities.
 *
 * Copyright (C) 2024 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/sys/compiler.h>
#include <stdint.h>

struct chs_address
{
  uint8_t  head;
  uint16_t sector:6, cylinder:10;
} __attribute__((packed));

struct partition_table_entry
{
  uint8_t status;
  struct chs_address chs_first_sector;
  uint8_t partition_type;
  struct chs_address chs_last_sector;
  uint32_t lba_first_sector;
  uint32_t num_sectors;
} __attribute__((packed));

EXTERN_C_BEGIN

struct partition_table_entry *get_partition_table(uint8_t *data);

EXTERN_C_END
